#include <stdbool.h>
#include "file_services.h"
#include "simpletools.h"

void create_directories()
{
    create_dir("/z");
    create_dir("/y");
    create_dir("/x");
    create_dir("/w");
    create_dir("/v");
    create_dir("/u");
    create_dir("/t");
    create_dir("/s");
    create_dir("/r");
    create_dir("/q");
    create_dir("/p");
    create_dir("/o");
    create_dir("/n");
    create_dir("/m");
    create_dir("/l");
    create_dir("/k");
    create_dir("/j");
    create_dir("/i");
    create_dir("/h");
    create_dir("/g");
    create_dir("/f");
    create_dir("/e");
    create_dir("/d");
    create_dir("/c");
    create_dir("/b");
    create_dir("/a");
}

void create_files()
{
    FILE* fp;

    fp = open_file("z.txt", "w");
    close_file(fp);
    fp = open_file("y.txt", "w");
    close_file(fp);
    fp = open_file("x.txt", "w");
    close_file(fp);
    fp = open_file("w.txt", "w");
    close_file(fp);
    fp = open_file("v.txt", "w");
    close_file(fp);
    fp = open_file("u.txt", "w");
    close_file(fp);
    fp = open_file("t.txt", "w");
    close_file(fp);
    fp = open_file("s.txt", "w");
    close_file(fp);
    fp = open_file("r.txt", "w");
    close_file(fp);
    fp = open_file("q.txt", "w");
    close_file(fp);
    fp = open_file("p.txt", "w");
    close_file(fp);
    fp = open_file("o.txt", "w");
    close_file(fp);
    fp = open_file("n.txt", "w");
    close_file(fp);
    fp = open_file("m.txt", "w");
    close_file(fp);
    fp = open_file("l.txt", "w");
    close_file(fp);
    fp = open_file("k.txt", "w");
    close_file(fp);
    fp = open_file("j.txt", "w");
    close_file(fp);
    fp = open_file("i.txt", "w");
    close_file(fp);
    fp = open_file("h.txt", "w");
    close_file(fp);
    fp = open_file("g.txt", "w");
    close_file(fp);
    fp = open_file("f.txt", "w");
    close_file(fp);
    fp = open_file("e.txt", "w");
    close_file(fp);
    fp = open_file("d.txt", "w");
    close_file(fp);
    fp = open_file("c.txt", "w");
    close_file(fp);
    fp = open_file("b.txt", "w");
    close_file(fp);
    fp = open_file("a.txt", "w");
    close_file(fp);
}    

void delete_directories()
{
    delete_dir("/a");
    delete_dir("/b");
    delete_dir("/c");
    delete_dir("/d");
    delete_dir("/e");
    delete_dir("/f");
    delete_dir("/g");
    delete_dir("/h");
    delete_dir("/i");
    delete_dir("/j");
    delete_dir("/k");
    delete_dir("/l");
    delete_dir("/m");
    delete_dir("/n");
    delete_dir("/o");
    delete_dir("/p");
    delete_dir("/q");
    delete_dir("/r");
    delete_dir("/s");
    delete_dir("/t");
    delete_dir("/u");
    delete_dir("/v");
    delete_dir("/w");
    delete_dir("/x");
    delete_dir("/y");
    delete_dir("/z");
}

void delete_files()
{
    delete_file("a.txt");
    delete_file("b.txt");
    delete_file("c.txt");
    delete_file("d.txt");
    delete_file("e.txt");
    delete_file("f.txt");
    delete_file("g.txt");
    delete_file("h.txt");
    delete_file("i.txt");
    delete_file("j.txt");
    delete_file("k.txt");
    delete_file("l.txt");
    delete_file("m.txt");
    delete_file("n.txt");
    delete_file("o.txt");
    delete_file("p.txt");
    delete_file("q.txt");
    delete_file("r.txt");
    delete_file("s.txt");
    delete_file("t.txt");
    delete_file("u.txt");
    delete_file("v.txt");
    delete_file("w.txt");
    delete_file("x.txt");
    delete_file("y.txt");
    delete_file("z.txt");
}    

int main(void)
{
    char file_path[MAX_PATH];

    init_fs();
    
    waitcnt(CNT + CLKFREQ);

    create_directories();
    create_files();

    index_dir_entries("/", false);
    print_dir_entries();

    delete_directories();
    delete_files();
    
    create_directories();
    create_files();

    index_dir_entries("/", true);
    print_dir_entries();

    delete_directories();
    delete_files();

    path_append(file_path, "You");    
    path_append(file_path, "say");
    path_append(file_path, "goodbye");
    path_append(file_path, "and");
    path_append(file_path, "I");
    path_append(file_path, "say");
    path_append(file_path, "hello");
    path_append(file_path, "hello");
    path_append(file_path, "hello.txt");
    
    print("%s", file_path);
    
    return 0;
}

